package com.example.elbuenopeso


import android.content.SharedPreferences
import android.os.Bundle
import android.widget.TextView
import androidx.appcompat.app.AppCompatActivity
import androidx.appcompat.app.AppCompatDelegate
import androidx.appcompat.widget.SwitchCompat
import androidx.preference.PreferenceManager
import androidx.core.content.ContextCompat

import com.example.elbuenopeso.R

class settingActivity : AppCompatActivity() {

    private lateinit var themeSwitch: SwitchCompat
    private lateinit var titleTextView: TextView
    private lateinit var descriptionTextView: TextView

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_setting)

        themeSwitch = findViewById(R.id.themeSwitch)
        titleTextView = findViewById(R.id.titleTextView)
        descriptionTextView = findViewById(R.id.descriptionTextView)

        // Retrieve the current theme setting
        val sharedPreferences = PreferenceManager.getDefaultSharedPreferences(this)
        val isNightMode = sharedPreferences.getBoolean("night_mode", false)
        themeSwitch.isChecked = isNightMode

        // Set up click listener for theme switch
        themeSwitch.setOnCheckedChangeListener { _, isChecked ->
            applyTheme(isChecked)
        }

        // Apply initial theme
        applyTheme(isNightMode)

        // Listen for changes in night mode
        delegate.localNightMode = AppCompatDelegate.MODE_NIGHT_FOLLOW_SYSTEM
    }

    private fun applyTheme(isNightMode: Boolean) {
        // Update the theme setting
        val sharedPreferences = PreferenceManager.getDefaultSharedPreferences(this)
        sharedPreferences.edit().putBoolean("night_mode", isNightMode).apply()

        // Apply the selected theme
        if (isNightMode) {
            AppCompatDelegate.setDefaultNightMode(AppCompatDelegate.MODE_NIGHT_YES)
            titleTextView.setTextColor(ContextCompat.getColor(this, R.color.text_color_dark))
            descriptionTextView.setTextColor(ContextCompat.getColor(this, R.color.text_color_dark))
        } else {
            AppCompatDelegate.setDefaultNightMode(AppCompatDelegate.MODE_NIGHT_NO)
            titleTextView.setTextColor(ContextCompat.getColor(this, R.color.text_color))
            descriptionTextView.setTextColor(ContextCompat.getColor(this, R.color.text_color))
        }
    }
}
