package com.example.elbuenopeso.ui.market

import AdAdapter
import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.GridView
import android.widget.ListView
import android.widget.ToggleButton
import androidx.fragment.app.Fragment
import androidx.lifecycle.ViewModelProvider
import com.example.elbuenopeso.databinding.FragmentMarketBinding
import com.example.elbuenopeso.models.AdModel
import com.example.elbuenopeso.R

class MarketFragment : Fragment() {

    private var _binding: FragmentMarketBinding? = null
    private val binding get() = _binding!!

    private lateinit var listView: ListView
    private lateinit var gridView: GridView
    private lateinit var toggleButton: ToggleButton
    private lateinit var adAdapter: AdAdapter

    private var isGridViewEnabled = false

    override fun onCreateView(
        inflater: LayoutInflater,
        container: ViewGroup?,
        savedInstanceState: Bundle?
    ): View {
        _binding = FragmentMarketBinding.inflate(inflater, container, false)
        val root: View = binding.root

        listView = binding.listView
        gridView = binding.gridView
        toggleButton = binding.toggleButton

        val annonces: List<AdModel> = listOf(
            AdModel("Poutre", "1 rue Jean-Pierre", R.drawable.pichu, 25.0),
            AdModel("Briques", "2 rue Jean-Michel", R.drawable.pichu, 16.0),
            AdModel("Poutre", "1 rue Jean-Pierre", R.drawable.pichu, 25.0),
            AdModel("Briques", "2 rue Jean-Michel", R.drawable.pichu, 16.0),
            AdModel("Mur en bois", "4 rue Alain-Juju", R.drawable.pichu, 7.2),
            AdModel("Maison de pierre", "7 rue Joris Belhomme", R.drawable.pichu, 3.99),
            AdModel("Téléphone de Timothé", "8 rue de Timothé", R.drawable.pichu, 0.85),
            AdModel("Oridnateur", "10 rue Jean-Charles", R.drawable.pichu, 104.98),
            AdModel("Charnières", "22 rue Jeanne-Marie", R.drawable.pichu, 2648.97),
            AdModel("Porte en marbre", "1 rue Jean-Pierre", R.drawable.pichu, 480.0),
            AdModel("Cheminée", "33 rue du Gouvernement", R.drawable.pichu, 800.0),
            AdModel("Poutre", "1 rue Jean-Pierre", R.drawable.pichu, 25.0),
            AdModel("Briques", "2 rue Jean-Michel", R.drawable.pichu, 16.0),
            AdModel("Mur en bois", "4 rue Alain-Juju", R.drawable.pichu, 7.2),
            AdModel("Maison de pierre", "7 rue Joris Belhomme", R.drawable.pichu, 3.99),
            AdModel("Téléphone de Timothé", "8 rue de Timothé", R.drawable.pichu, 0.85),
            AdModel("Oridnateur", "10 rue Jean-Charles", R.drawable.pichu, 104.98),
            AdModel("Charnières", "22 rue Jeanne-Marie", R.drawable.pichu, 2648.97),
            AdModel("Porte en marbre", "1 rue Jean-Pierre", R.drawable.pichu, 480.0),
            AdModel("Cheminée", "33 rue du Gouvernement", R.drawable.pichu, 800.0),
            // Add more AdModel items as needed
        )

        adAdapter = AdAdapter(requireContext(), annonces)
        listView.adapter = adAdapter

        toggleButton.setOnCheckedChangeListener { _, isChecked ->
            isGridViewEnabled = isChecked
            updateView()
        }

        return root
    }

    private fun updateView() {
        if (isGridViewEnabled) {
            listView.visibility = View.GONE
            gridView.visibility = View.VISIBLE
            gridView.adapter = adAdapter
        } else {
            gridView.visibility = View.GONE
            listView.visibility = View.VISIBLE
            listView.adapter = adAdapter
        }
    }

    override fun onDestroyView() {
        super.onDestroyView()
        _binding = null
    }
}
